export function chainEventHandlers(first, ...rest) {
  const result = {
    ...first
  };
  for (const obj of rest) {
    for (const key in obj) {
      const value = obj[key];
      const prev = result[key];
      if (typeof prev === 'function' && typeof value === 'function') {
        result[key] = (...args) => {
          prev(...args);
          return value(...args);
        };
      } else {
        result[key] = value;
      }
    }
  }
  return result;
}
//# sourceMappingURL=chainEventHandlers.mjs.map